/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JFrame.java to edit this template
 */

package my.numberaddition;

import java.util.*;
import javax.swing.*;

import jssc.*;
//import jssc.SerialPort.*;
import jssc.SerialPortEvent;
import jssc.SerialPortEventListener;
import jssc.SerialPortException;
//import java.nio.*;
import java.util.concurrent.TimeUnit;

import static my.numberaddition.frameExecutor.*;
/**
 *
 * @author a.sveshnikov
 */
public class daliCommands extends javax.swing.JFrame {

    //SerialPort comPort
    /**
     * Creates new form NumberAdditionUI
     */
    String portName;
    static SerialPort port; // = new SerialPort("COM3");;
    static boolean portAssigned = false;
    static boolean dataReceived = false;
    boolean standartCommandSelected = true;
    byte addrType;
    //static Win10RxTx rxtx = new Win10RxTx();
    static frameExecutor frameExec = new frameExecutor();
    
    String daliCommandsStrList[] = { "- DIRECT ARC POWER CONTROL", "0 OFF", "1 UP", "2 DOWN",
            "3 STEP UP", "4 STEP DOWN","5 RECALL MAX LEVEL", "6 RECALL MIN LEVEL",
            "7 STEP DOWN AND OFF", "8 ON AND STEP UP",
            "9 ENABLE DAPC SEQUENCE", "10 GO TO LAST ACTIVE LEVEL",
            "16 GO TO SCENE 0", "17 GO TO SCENE 1", "18 GO TO SCENE 2", "19 GO TO SCENE 3",
            "20 GO TO SCENE 4", "21 GO TO SCENE 5", "22 GO TO SCENE 6", "23 GO TO SCENE 7",
            "24 GO TO SCENE 8", "25 GO TO SCENE 9", "26 GO TO SCENE 10", "27 GO TO SCENE 11",
            "28 GO TO SCENE 12", "29 GO TO SCENE 13", "30 GO TO SCENE 14", "31 GO TO SCENE 15",
            "32 RESET", "33 STORE ACTUAL LEVEL IN THE DTR", "34 SAVE PERSISTENT VARIABLES",
            "35 SET DTR0 AS OPERATING MODE", "36 RESET MEMORY BANK (DTR0)",
            "37 IDENTIFY DEVICE", "42 STORE THE DTR AS MAX LEVEL",
            "43 STORE THE DTR AS MIN LEVEL", "44 STORE THE DTR AS SYSTEM FAILURE LEVEL",
            "45 STORE THE DTR AS POWERON LEVEL", "46 STORE THE DTR AS FADE TIME",
            "47 STORE THE DTR AS FADE RATE", "48 STORE THE DTR AS EXTENDED FADE TIME",
            "64 STORE THE DTR AS SCENE 0", "65 STORE THE DTR AS SCENE 1", "66 STORE THE DTR AS SCENE 2",
            "67 STORE THE DTR AS SCENE 3", "68 STORE THE DTR AS SCENE 4", "69 STORE THE DTR AS SCENE 5",
            "70 STORE THE DTR AS SCENE 6", "71 STORE THE DTR AS SCENE 7", "72 STORE THE DTR AS SCENE 8",
            "73 STORE THE DTR AS SCENE 9", "74 STORE THE DTR AS SCENE 10", "75 STORE THE DTR AS SCENE 11",
            "76 STORE THE DTR AS SCENE 12", "77 STORE THE DTR AS SCENE 13", "78 STORE THE DTR AS SCENE 14",
            "79 STORE THE DTR AS SCENE 15", "80 REMOVE FROM SCENE 0", "81 REMOVE FROM SCENE 1",
            "82 REMOVE FROM SCENE 2", "83 REMOVE FROM SCENE 3", "84 REMOVE FROM SCENE 4",
            "85 REMOVE FROM SCENE 5", "86 REMOVE FROM SCENE 6", "87 REMOVE FROM SCENE 7",
            "88 REMOVE FROM SCENE 8", "89 REMOVE FROM SCENE 9", "90 REMOVE FROM SCENE 10",
            "91 REMOVE FROM SCENE 11", "92 REMOVE FROM SCENE 12", "93 REMOVE FROM SCENE 13",
            "94 REMOVE FROM SCENE 14", "95 REMOVE FROM SCENE 15", "96 ADD TO GROUP 0",
            "97 ADD TO GROUP 1", "98 ADD TO GROUP 2", "99 ADD TO GROUP 3", "100 ADD TO GROUP 4",
            "101 ADD TO GROUP 5", "102 ADD TO GROUP 6", "103 ADD TO GROUP 7", "104 ADD TO GROUP 8",
            "105 ADD TO GROUP 9", "106 ADD TO GROUP 10", "107 ADD TO GROUP 11", "108 ADD TO GROUP 12",
            "109 ADD TO GROUP 13", "110 ADD TO GROUP 14", "111 ADD TO GROUP 15",
            "112 REMOVE FROM GROUP 0", "113 REMOVE FROM GROUP 1", "114 REMOVE FROM GROUP 2",
            "115 REMOVE FROM GROUP 3", "116 REMOVE FROM GROUP 4", "117 REMOVE FROM GROUP 5",
            "118 REMOVE FROM GROUP 6", "119 REMOVE FROM GROUP 7", "120 REMOVE FROM GROUP 8",
            "121 REMOVE FROM GROUP 9", "122 REMOVE FROM GROUP 10", "123 REMOVE FROM GROUP 11",
            "124 REMOVE FROM GROUP 12", "125 REMOVE FROM GROUP 13", "126 REMOVE FROM GROUP 14",
            "127 REMOVE FROM GROUP 15", "128 STORE DTR AS SHORT ADDRESS", "129 ENABLE WRITE MEMORY",
            "144 QUERY STATUS", "145 QUERY CONTROIL GEAR", "146 QUERY LAMP FAILKURE",
            "147 QUERY LAMP POWER ON", "148 QUERY LIMIT ERROR", "149 QUERY RESET STATE",
            "150 QUERY MISSING SHORT ADDRESS", "151 QUERY VERSION NUMBER", "152 QUERY CONTENT DTR",
            "153 QUERY DEVICE TYPE", "154 QUERY PHYSICAL MINIMUM LEVEL", "155 QUERY POWER FAILURE",
            "156 QUERY CONTENT DTR1", "157 QUERY CONTENT DTR2", "158 QUERY OPERATING MODE",
            "159 QUERY LIGHT SOURCE TYPE", "160 QUERY ACTUAL LEVEL",
            "161 QUERY MAX LEVEL", "162 QUERY MIN LEVEL", "163 QUERY POWERON LEVEL",
            "164 QUERY SYSTEM FAILURE LEVEL", "165 QUERY FADE TIME/FADE RATE",
            "166 QUERY MANUFACTURER SPECIFIC MODE", "167 QUERY NEXT DEVICE TYPE", "168 QUERY EXTENDED FADE TIME",
            "170 QUERY CONTROL GEAR FAMILY", "176 QUERY SCENE LEVEL 0",
            "177 QUERY SCENE LEVEL 1", "178 QUERY SCENE LEVEL 2", "179 QUERY SCENE LEVEL 3",
            "180 QUERY SCENE LEVEL 4", "181 QUERY SCENE LEVEL 5", "182 QUERY SCENE LEVEL 6",
            "183 QUERY SCENE LEVEL 7", "184 QUERY SCENE LEVEL 8", "185 QUERY SCENE LEVEL 9",
            "186 QUERY SCENE LEVEL 10", "187 QUERY SCENE LEVEL 11", "188 QUERY SCENE LEVEL 12",
            "189 QUERY SCENE LEVEL 13", "190 QUERY SCENE LEVEL 14", "191 QUERY SCENE LEVEL 15",
            "192 QUERY GROUPS 0-7", "193 QUERY GROUPS 8-15", "194 QUERY RANDOM ADDRESS H",
            "195 QUERY RANDOM ADDRESS M", "196 QUERY RANDOM ADDRESS L", "197 READ MEMORY LOCATION",
            "255 QUERY EXTENDED VERSION NUM", "256 TERMINATE", "257 DTR0", "258 INITIALISE",
            "259 RANDOMISE", "260 COMPARE", "261 WITHDRAW", "264 SEARCHADDRH",
            "265 SEARCHADDRM", "266 SEARCHADDRL", "267 PROGRAM SHORT ADDRESS",
            "268 VERIFY SHORT ADDRESS", "269 QUERY SHORT ADDRESS",
            "272 ENABLE DEVICE TYPE X", "273 DTR1", "274 DTR2", "275 WRITE MEMORY LOCATION",
            "276 WRITE MEMORY LOCATION - NO REPLY"};
    String daliSpec202ExtCommandsStrList[] =
    {
        "224 REST", "225 INHIBIT", "226 RE-LIGHT/RESET INHIBIT", "227 START FUNCTION TEST",
        "228 START DURATION TEST", "229 STOP TEST", "230 RESET FUNCTION TEST DONE FLAG",
        "231 RESET DURATION TEST DONE FLAG", "232 RESET LAMP TIME", "233 STORE DTR AS EMERGENCY LEVEL",
        "234 STORE TEST DELAY TIME HIGH BYTE", "235 STORE TEST DELAY TIME LOW BYTE",
        "236 STORE FUNCTION TEST INTERVAL", "237 STORE DURATION TEST INTERVAL", "238 STORE TEST EXECUTION TIMEOUT",
        "239 STORE PROLONG TIME", "240 START IDENTIFICATION", "241 QUERY BATTERY CHARGE",
        "242 QUERY TEST TIMING", "243 QUERY DURATION TEST RESULT", "244 QUERY LAMP EMERGENCY TIME",
        "245 QUERY LAMP TOTAL OPERATION TIME", "246 QUERY EMERGENCY LEVEL", "247 QUERY EMERGENCY MIN LEVEL",
        "248 QUERY EMERGENCY MAX LEVEL", "249 QUERY RATED DURATION", "250 QUERY EMERGENCY MODE",
        "251 QUERY FEATURES", "252 QUERY FAILURE STATUS", "253 QUERY EMERGENCY STATUS",
        "254 PEFORM DTR SELECTED FUNCTION", "255 QUERY EXTENDED VERSION NUMBER"
    };
    
    String daliSpec209ExtCommandsStrList[] =
    {
       "224 SET TEMPORARY x-COORDINATE", "225 SET TEMPORARY y-COORDINATE", "226 ACTIVATE",
       "227 x-COORDINATE STEP UP", "228 x-COORDINATE STEP DOWN", "229 y-COORDINATE STEP UP",
       "230 y-COORDINATE STEP DOWN", "231 SET TEMPORARY COLOUR TEMPERATURE Tc",
       "232 COLOUR TEMPERATURE Tc STEP COOLER",  "233 COLOUR TEMPERATURE TC STEP WARMER",
       "234 SET TEMPORARY PRIMARY N DIMLEVEL", "235 SET TEMPORARY RGB DIMLEVEL",
       "236 SET TEMPORARY WAF DIMLEVEL", "237 SET TEMPORARY RGBWAF CONTROL", "238 COPY REPORT TO TEMPORARY",
       "240 STORE TY PRIMARY N", "241 STORE xy-COORDINATE PRIMARY N", "242 STORE COLOUR TEMPERATURE TC LIMIT",
       "243 STORE GEAR FEATURES/STATUS", "245 ASSIGN COLOUR TO LINKED CHANNEL", "246 START AUTO CALIBRATION",
       "247 QUERY GEAR FEATURES/STATUS", "248 QUERY COLOUR STATUS", "249 QUERY COLOUR TYPE FEATURES",
       "250 QUERY COLOUR VALUE", "251 QUERY RGBWAF CONTROL", "252 QUERY ASSIGNED COLOUR",
       "255 QUERY EXTENDED VERSION NUMBER",
    };
    
    String daliSpec207ExtCommandsStrList[]  = 
    {
       "224 REFERENCE SYSTEM POWER", "225 ENABLE CURRENT PROTECTOR", "226 DISABLE CURRENT PROTECTOR",
       "227 SELECT DIMMING CURVE", "228 STORE DTR AS FAST FADE TIME", "237 QUERY GEAR TYPE",
       "238 QUERY DIMMING CURVE", "239 QUERY POSSIBLE OPERATING MODES", "240 QUERY FEATURES",
       "241 QUERY FAILURE STATUS", "242 QUERY SHORT CIRCUIT", "243 QUERY OPEN CIRCUIT",
       "244 QUERY LOAD DECREASE", "245 QUERY LOAD INCREASE", "246 QUERY CURRENT PROTECTOR ACTIVE",
       "247 QUERY THERMAL SHUT DOWN", "248 QUERY THERMAL OVERLOAD", "249 QUERY REFERENCE RUNNING",
       "250 QUERY REFERENCE MEASUREMENT FAILED", "251 QUERY CURRENT PROTECTOR ENABLED", "252 QUERY OPERATING MODE",
       "253 QUERY FAST FADE TIME", "254 QUERY MIN FAST FADE TIME",  "255 QUERY EXTENDED VERSION NUMBER",
    };    
      
    String daliSpec205ExtCommandsStrList[] =
    {
       "224 REFERENCE SYSTEM POWER", "225 SELECT DIMMING CURVE", "238 QUERY DIMMING CURVE",
       "239 QUERY DIMMER STATUS", "240 QUERY FEATURES", "241 QUERY FAILURE STATUS",
       "242 QUERY DIMMER TEMPERATURE", "243 QUERY RMS SUPPLY VOLTAGE", "244 QUERY SUPPLY FREQUENCY",
       "245 QUERY RMS LOAD VOLTAGE", "246 QUERY RMS LOAD CURRENT", "247 QUERY REAL LOAD POWER",
       "248 QUERY LOAD RATING", "249 QUERY REFERENCE RUNNING", "250 QUERY REFERENCE MEASUREMENT FAILED",
       "255 QUERY EXTENDED VERSION NUMBER",
    };
    
    static JTextField hexRplTxtFldInst;
    static JTextField decRplTxtFieldInst;
    
    public daliCommands() {
        
        initComponents();
        hexRplTxtFldInst = hexReplyTextField;
        decRplTxtFieldInst = decReplyTextField;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jMenu1 = new javax.swing.JMenu();
        buttonGroup1 = new javax.swing.ButtonGroup();
        daliExtendedTestCmdsComboBox = new javax.swing.JComboBox<>();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        specSelComboBox = new javax.swing.JComboBox<>();
        DaliCommandComboBox = new javax.swing.JComboBox<>();
        jLabel3 = new javax.swing.JLabel();
        daliDataSetSlider = new javax.swing.JSlider(0, 255, 0);
        dataDecEditField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        dataHexEditField = new javax.swing.JTextField();
        sendButton = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        BroadcastUnaddressedSelectButton = new javax.swing.JRadioButton();
        GroupSelectButton = new javax.swing.JRadioButton();
        BroadcastSelectButton = new javax.swing.JRadioButton();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        dataDecTextField = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        dataHexTextField = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        decReplyTextField = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        hexReplyTextField = new javax.swing.JTextField();
        IndividualAddressSelectButton = new javax.swing.JRadioButton();
        groupSendSpinner = new javax.swing.JSpinner();
        addressSendSpinner = new javax.swing.JSpinner();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();

        jMenu1.setText("jMenu1");

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        daliExtendedTestCmdsComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(daliSpec207ExtCommandsStrList));
        daliExtendedTestCmdsComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                daliExtendedTestCmdsComboBoxActionPerformed(evt);
            }
        });

        jLabel1.setText("Расширенные команды");

        jLabel2.setText("Спецификация");

        specSelComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "207", "205", "209", "202" }));
        specSelComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                specSelComboBoxActionPerformed(evt);
            }
        });

        DaliCommandComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(daliCommandsStrList));
        DaliCommandComboBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                DaliCommandComboBoxItemStateChanged(evt);
            }
        });
        DaliCommandComboBox.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                DaliCommandComboBoxMouseClicked(evt);
            }
        });
        DaliCommandComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DaliCommandComboBoxActionPerformed(evt);
            }
        });

        jLabel3.setText("Данные");

        daliDataSetSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                daliDataSetSliderStateChanged(evt);
            }
        });

        dataDecEditField.setText("0");
        dataDecEditField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dataDecEditFieldActionPerformed(evt);
            }
        });

        jLabel4.setText("DEC");

        jLabel5.setText("HEX");

        dataHexEditField.setText("00");
        dataHexEditField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dataHexEditFieldActionPerformed(evt);
            }
        });

        sendButton.setText("Отправить");
        sendButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sendButtonActionPerformed(evt);
            }
        });

        jLabel6.setText("Куда отправить команду");

        buttonGroup1.add(BroadcastUnaddressedSelectButton);
        BroadcastUnaddressedSelectButton.setText("Всем без адреса(Broadcast Unaddressed)");
        BroadcastUnaddressedSelectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BroadcastUnaddressedSelectButtonActionPerformed(evt);
            }
        });

        buttonGroup1.add(GroupSelectButton);
        GroupSelectButton.setText("Группе");
        GroupSelectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                GroupSelectButtonActionPerformed(evt);
            }
        });

        buttonGroup1.add(BroadcastSelectButton);
        BroadcastSelectButton.setSelected(true);
        BroadcastSelectButton.setText("Всем(Broadcast)");
        BroadcastSelectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BroadcastSelectButtonActionPerformed(evt);
            }
        });

        jLabel7.setText("Команда");

        jLabel8.setText("DEC");

        dataDecTextField.setText("0");

        jLabel9.setText("HEX");

        dataHexTextField.setText("0");

        jLabel10.setText("Ответ");

        jLabel11.setText("DEC");

        decReplyTextField.setText("0");
        decReplyTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                decReplyTextFieldActionPerformed(evt);
            }
        });

        jLabel12.setText("HEX");

        hexReplyTextField.setText("0");
        hexReplyTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                hexReplyTextFieldActionPerformed(evt);
            }
        });

        buttonGroup1.add(IndividualAddressSelectButton);
        IndividualAddressSelectButton.setText("По адресу");
        IndividualAddressSelectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                IndividualAddressSelectButtonActionPerformed(evt);
            }
        });

        jMenu2.setText("COM-Порт");

        jMenuItem1.setText("Открыть");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem1);

        jMenuItem2.setText("Закрыть");
        jMenu2.add(jMenuItem2);

        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(DaliCommandComboBox, javax.swing.GroupLayout.Alignment.LEADING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(daliExtendedTestCmdsComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 192, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 192, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(specSelComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 181, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(43, 43, 43))
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(12, 12, 12)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(BroadcastSelectButton, javax.swing.GroupLayout.PREFERRED_SIZE, 120, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel6)
                            .addComponent(BroadcastUnaddressedSelectButton)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(IndividualAddressSelectButton)
                                    .addComponent(GroupSelectButton))
                                .addGap(18, 18, 18)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(groupSendSpinner, javax.swing.GroupLayout.DEFAULT_SIZE, 133, Short.MAX_VALUE)
                                    .addComponent(addressSendSpinner)))))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(sendButton)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addGroup(layout.createSequentialGroup()
                                    .addComponent(jLabel8)
                                    .addGap(18, 18, 18)
                                    .addComponent(dataDecTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 86, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGroup(layout.createSequentialGroup()
                                    .addComponent(jLabel11)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(decReplyTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE))))
                        .addGap(47, 47, 47)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel9)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(dataHexTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 103, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel12)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(hexReplyTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 103, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel7)
                    .addComponent(daliDataSetSlider, javax.swing.GroupLayout.PREFERRED_SIZE, 452, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel10)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel4)
                                .addGap(18, 18, 18)
                                .addComponent(dataDecEditField, javax.swing.GroupLayout.PREFERRED_SIZE, 115, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(98, 98, 98)
                        .addComponent(jLabel5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(dataHexEditField, javax.swing.GroupLayout.PREFERRED_SIZE, 121, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(0, 23, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(DaliCommandComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(specSelComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(daliExtendedTestCmdsComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(daliDataSetSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(dataDecEditField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5)
                    .addComponent(dataHexEditField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(BroadcastSelectButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(BroadcastUnaddressedSelectButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(GroupSelectButton)
                    .addComponent(groupSendSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(IndividualAddressSelectButton)
                    .addComponent(addressSendSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(dataDecTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel9)
                    .addComponent(dataHexTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel10)
                .addGap(7, 7, 7)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(decReplyTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel11)
                    .addComponent(jLabel12)
                    .addComponent(hexReplyTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(sendButton)
                .addContainerGap(18, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void DaliCommandComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DaliCommandComboBoxActionPerformed
        standartCommandSelected = true;
    }//GEN-LAST:event_DaliCommandComboBoxActionPerformed

    private void DaliCommandComboBoxMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_DaliCommandComboBoxMouseClicked
        
    }//GEN-LAST:event_DaliCommandComboBoxMouseClicked

    private void daliDataSetSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_daliDataSetSliderStateChanged
        Integer val = daliDataSetSlider.getValue(); //*255/100;
        String valStr = val.toString();
        dataDecEditField.setText(valStr); // TODO add your handling code here: // TODO add your handling code here:
        String HexStr = Integer.toHexString(val);
        dataHexEditField.setText(HexStr); 
    }//GEN-LAST:event_daliDataSetSliderStateChanged

    private void dataDecEditFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dataDecEditFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_dataDecEditFieldActionPerformed

    private void dataHexEditFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dataHexEditFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_dataHexEditFieldActionPerformed

    private void DaliCommandComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_DaliCommandComboBoxItemStateChanged
        // TODO add your handling code here:
    }//GEN-LAST:event_DaliCommandComboBoxItemStateChanged

    private void specSelComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_specSelComboBoxActionPerformed
        String specStr = specSelComboBox.getSelectedItem().toString();
        if(specStr.equals("207"))
        {    
            daliExtendedTestCmdsComboBox.removeAllItems();
            daliExtendedTestCmdsComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(daliSpec207ExtCommandsStrList));
        }    
        else if(specStr.equals("202"))
        {
            daliExtendedTestCmdsComboBox.removeAllItems();
            daliExtendedTestCmdsComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(daliSpec202ExtCommandsStrList));
        }
        else if(specStr.equals("205"))
        {
            daliExtendedTestCmdsComboBox.removeAllItems();
            daliExtendedTestCmdsComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(daliSpec205ExtCommandsStrList));
        }
        else if(specStr.equals("209"))
        {
            daliExtendedTestCmdsComboBox.removeAllItems();
            daliExtendedTestCmdsComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(daliSpec209ExtCommandsStrList));
        }
    }//GEN-LAST:event_specSelComboBoxActionPerformed

    private void daliExtendedTestCmdsComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_daliExtendedTestCmdsComboBoxActionPerformed
        standartCommandSelected = false;        
    }//GEN-LAST:event_daliExtendedTestCmdsComboBoxActionPerformed

    private void sendButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sendButtonActionPerformed
        if(!portAssigned)
        {
            //Some message here
            JOptionPane.showMessageDialog(daliCommands.this, "Сначала надо открыть порт");
            return;
        }  
        byte data = (byte)Integer.parseInt(dataDecEditField.getText());//ui->dataDecEdit->text().toInt();
        String cmdStr;
        if(standartCommandSelected)
        {
            cmdStr =  DaliCommandComboBox.getSelectedItem().toString();
        } 
        else
        {
            cmdStr = daliExtendedTestCmdsComboBox.getSelectedItem().toString();    
        }
        
        //try
        //{
        //    TimeUnit.MILLISECONDS.sleep(500);
        //}
        //catch(Exception e)
        //{
        //    System.out.println("timeout fails");
        //}    
                
        int dummy = (Integer)groupSendSpinner.getValue();
        byte groupDest = (byte)dummy;
        dummy = (Integer)addressSendSpinner.getValue();
        byte addrDest =  (byte)dummy;
        
        
        
        byte addr_type = frameExecutor.BROADCAST_ADDR ;
        if( BroadcastSelectButton.isSelected() )
        {
            addr_type = frameExecutor.BROADCAST_ADDR; 
        }   
        else if( BroadcastUnaddressedSelectButton.isSelected() )
        {
            addr_type = frameExecutor.BROADCAST_UNADDRESSED;
        }    
        else if( GroupSelectButton.isSelected() )
        {
            addr_type = frameExecutor.GROUP_ADDR;
        }  
         else if( IndividualAddressSelectButton.isSelected() )
        {
            addr_type = frameExecutor.INDIVIDUAL_ADDR;
        }  
        
        byte specification = frameExec.getSpec(specSelComboBox.getSelectedItem().toString());
        
        byte dataToSend[] = {0, 0, 0, 0, 0}; 
        frameExec.buildCmd( data, cmdStr, addr_type, groupDest, addrDest, specification,  dataToSend );
        
        byte addr = frameExec.getAddress();
        byte opcode = frameExec.getOpcode();
        String resStr = String.format("%02X", addr);
        String opcodeStr = String.format("%02X", opcode);
        resStr += " " + opcodeStr;
        dataHexTextField.setText(resStr);
        int addrInt = Byte.toUnsignedInt(addr);
        int opcodeInt = Byte.toUnsignedInt(opcode);
        resStr = String.format("%d", addrInt );
        opcodeStr = String.format("%d", opcodeInt);
        resStr += " " + opcodeStr;
        dataDecTextField.setText(resStr);
        
        int len = dataToSend.length;
        try{
            if(port != null)
            {    
               // TimeUnit.MILLISECONDS.sleep(100);
                port.writeBytes(dataToSend); 
                //TimeUnit.MILLISECONDS.sleep(100);
            }
        }
        catch(Exception e){
            System.out.println("port write fault");
        }
        System.out.println("Sent " + len + " byte(s)");
    }//GEN-LAST:event_sendButtonActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        ArrayList<String> portlist = new ArrayList<String>();

        for(String port : SerialPortList.getPortNames()) {
            System.out.println(port);
            portlist.add(port);
        }
        String[] portStrArray = portlist.toArray(new String[0]);
        ImageIcon  icon          = null;
        Object result = JOptionPane.showInputDialog(
                                        daliCommands.this,
                                        "Выберите порт:",
                                        "Выбор порта", 
                                        JOptionPane.QUESTION_MESSAGE, 
                                        icon, portStrArray, portStrArray[0]);
        // Диалоговое окно вывода сообщения
        //JOptionPane.showMessageDialog(daliCommands.this, result);
        if(result == null)
        {
            portAssigned = false;
        }  
        else
        {    
            portName = result.toString();
            port = new SerialPort(portName);
            try{
                port.openPort();
                port.setParams(9600, 8, 1, 0); 
                port.setFlowControlMode(SerialPort.FLOWCONTROL_NONE);
                System.out.println("SELECTED PORT " + portName);
                portAssigned = true;
               
            } catch (Exception e) {
		System.out.println("port open exception");
            }
        }    
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void BroadcastSelectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BroadcastSelectButtonActionPerformed
        addrType = frameExecutor.BROADCAST_ADDR;
    }//GEN-LAST:event_BroadcastSelectButtonActionPerformed

    private void BroadcastUnaddressedSelectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BroadcastUnaddressedSelectButtonActionPerformed
        addrType =  frameExecutor.BROADCAST_UNADDRESSED;
    }//GEN-LAST:event_BroadcastUnaddressedSelectButtonActionPerformed

    private void decReplyTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_decReplyTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_decReplyTextFieldActionPerformed

    private void hexReplyTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_hexReplyTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_hexReplyTextFieldActionPerformed

    private void IndividualAddressSelectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_IndividualAddressSelectButtonActionPerformed
        addrType =  INDIVIDUAL_ADDR;
    }//GEN-LAST:event_IndividualAddressSelectButtonActionPerformed

    private void GroupSelectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_GroupSelectButtonActionPerformed
        addrType =  GROUP_ADDR;
    }//GEN-LAST:event_GroupSelectButtonActionPerformed
 
    class RxData
    {
        byte data;
         
        public RxData(byte dt)
        {
            data = dt;
        }  
        
        public void processRxData()
        {
            String resStr = String.format("%02X", data);
            System.out.println("Got reply (hex)" + resStr);
            hexReplyTextField.setText(resStr); 
        } 

    }
 
    static class SerialPortReader implements SerialPortEventListener {

        private SerialPort serialPort;

        public SerialPortReader(SerialPort serialPort) {
            this.serialPort = serialPort;
        }
        
        private boolean comPortProcessData(byte[] data)
        {
            if(data.length == 0)
            {
                System.out.println("ERROR receiving data");
                return false;
            }
            boolean rval = frameExec.parse(data);
            if(!rval)
                return false;
            dataReceived = true;          
            return true;
        }    
        
        public void serialEvent(SerialPortEvent event) {
      /*
       * Объект типа SerialPortEvent несёт в себе информацию о том какое событие
       * произошло и значение. Так например если пришли данные то метод
       * event.getEventValue() вернёт нам количество байт во входном буфере.
       */
            if (event.isRXCHAR()) {
                if (event.getEventValue() > 0) {
                    try {
                        System.out.println("Got reply");
                        byte buffer[] = serialPort.readBytes();
                        boolean res = comPortProcessData(buffer);
                       
                        byte replyByte = frameExec.getReply();
                        String resStr = String.format("%02X", replyByte);
                        
                        hexRplTxtFldInst.setText(resStr); 
                        resStr = String.format("%d", replyByte);
                        //System.out.println("Got reply (dec)" + resStr);
                        decRplTxtFieldInst.setText(resStr); 
                    } catch (SerialPortException ex) {
                        ex.printStackTrace();
                    }
                }
            } else if (event.isCTS()) {
                /*
                * Если изменилось состояние линии CTS, то метод event.getEventValue()
                * вернёт 1 если линия включения и 0 если выключена.
                */
                if (event.getEventValue() == 1) {
                    System.out.println("CTS - ON");
                } else {
                    System.out.println("CTS - OFF");
                }
            } else if (event.isDSR()) {
                if (event.getEventValue() == 1) {
                    System.out.println("DSR - ON");
                } else {
                    System.out.println("DSR - OFF");
                }
            }
        }
    }
 
    public static void main(String args[]) {
        try {
            
            //Define a working thread to read RxTx and display in the console
            Thread readData = new Thread(new Runnable() {
                @Override
                public void run() {
                    boolean portReaderCreated = false;
                    SerialPortReader portReader; 
                    while(true) {
			if( (!portReaderCreated) && portAssigned )
                        {
                            try{
                                portReader = new SerialPortReader(port);
                                port.addEventListener(portReader, SerialPort.MASK_RXCHAR);
                            }
                            catch(Exception e)
                            {
                                System.out.println("event listener creation fault");
                            } 
                            portReaderCreated = true;
                        }
                        
                       // if(portReaderCreated)
                       // {    
                       //     try {
                       //         byte[] buffer = port.readBytes(4);//Read 4 bytes from serial port
                       //         if(buffer.length == 4)
                       //         {
                       //             System.out.println("got 4 bytes");
                        //        } 
                        //        else
                        //        {
                        //            if(buffer.length > 0)
                        //            {  
                        //                System.out.println("got some bytes");
                        //            }
                        //        }     
                       //     }    
                        //    catch(Exception e)
                        //    {
                        //        System.out.println("fault on rcv");       
                        //    } 
                        //}
                        //if(dataReceived)
                        //{
                        //    byte replyByte = frameExec.getReply();
                        //    String resStr = String.format("%02X", replyByte);
                        //    System.out.println("Got reply (hex)" + resStr);
                           // hexReplyTextField.setText(resStr); 
                        //    resStr = String.format("%d", (int)replyByte);
                           // decReplyTextField.setText(resStr); 
                        //    System.out.println("Got reply (dec)" + resStr);
                        //    dataReceived = false;
                        //}    
                    }
                }				
            });
            readData.start();
	} catch (Exception e) {
		e.printStackTrace();
	} finally {
		//close RxTx to release all resources
		System.out.println("Finished!");
	}
 
        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new daliCommands().setVisible(true);
                
            }
        });
  
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton BroadcastSelectButton;
    private javax.swing.JRadioButton BroadcastUnaddressedSelectButton;
    private javax.swing.JComboBox<String> DaliCommandComboBox;
    private javax.swing.JRadioButton GroupSelectButton;
    private javax.swing.JRadioButton IndividualAddressSelectButton;
    private javax.swing.JSpinner addressSendSpinner;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JSlider daliDataSetSlider;
    private javax.swing.JComboBox<String> daliExtendedTestCmdsComboBox;
    private javax.swing.JTextField dataDecEditField;
    private javax.swing.JTextField dataDecTextField;
    private javax.swing.JTextField dataHexEditField;
    private javax.swing.JTextField dataHexTextField;
    private javax.swing.JTextField decReplyTextField;
    private javax.swing.JSpinner groupSendSpinner;
    private javax.swing.JTextField hexReplyTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JButton sendButton;
    private javax.swing.JComboBox<String> specSelComboBox;
    // End of variables declaration//GEN-END:variables
}
